package com.adamatomic.Mode
{
	import flash.display.BitmapData;
	import flash.filters.DisplacementMapFilter;
	import flash.geom.Rectangle;
	import org.flixel.*;
	import flash.utils.Dictionary;

	public class PlayState extends FlxState
	{	
		private var cx:int;//coords of chart
		private var cy:int;
		
		private var px:int;//coords of player
		private var py:int;
		private var carrying:int;//what carrying
		private var elapsed:Number;
		private var elapsed2:Number;
		private var unburied:int;
		private var unburiedLbl:FlxText;
		
		private var mt:MersenneTwister;
		
		public static const displaywidth:int = 40;
		public static const displayheight:int = 40;
		public static const tilesize:int = 15;
		public static const xoffset:int = displaywidth / 2;
		public static const yoffset:int = displayheight / 2;
		
		private var screen:Vector.<Vector.<int>>;

		// 0 1 2
		// 3 4 5
		// 6 7 8
		private var area:Vector.<Vector.<Vector.<int>>>;
		private var entityCache:Dictionary;

		override public function create():void
		{			
			FlxG.mouse.cursor = null;
			mt = new MersenneTwister();
			elapsed = 0;
			elapsed2 = 0;
			carrying = 0;
			
			var a:Array=new Array;
			
			FlxG.playMusic(MenuState.SndGame);		

			cx = 0;
			cy = 0;
			
			px = xoffset;
			py = yoffset;
			
			entityCache = new Dictionary();
			
			area = new Vector.<Vector.<Vector.<int>>>;
			
			var ad:AreaDat;
			ad = generateArea( -1, -1);
			area.push(ad.geography);
			ad = generateArea( 0, -1);
			area.push(ad.geography);
			ad = generateArea( +1, -1);
			area.push(ad.geography);
			ad = generateArea( -1, 0);
			area.push(ad.geography);
			ad = generateArea( 0, 0);
			area.push(ad.geography);
			ad = generateArea( +1, 0);
			area.push(ad.geography);
			ad = generateArea( -1, +1);
			area.push(ad.geography);
			ad = generateArea( 0, +1);
			area.push(ad.geography);
			ad = generateArea( +1, +1);
			area.push(ad.geography);
			unburied = 17000000;
			unburiedLbl = new FlxText(10, 600, 600, unburied.toString() + " people unburied");
			unburiedLbl.color = 0xffffffff;
			unburiedLbl.size = 16;
			this.add(unburiedLbl);
			for (var k:int = 0; k < 9; k++)
			{
				var tempscreen:Vector.<Vector.<int>> = new Vector.<Vector.<int>>;
					
				for (var i:int = 0; i < displayheight; i++)
				{
					var row:Vector.<int> = new Vector.<int>;
					
					for (var j:int = 0; j < displaywidth ; j++)
					{
						if (Math.random()<0.5)
							row.push(0);
						else
							row.push(1);
					}
					tempscreen.push(row);
				}
				area.push(tempscreen);
			}
			
			screen = new Vector.<Vector.<int>>;
			
			for (i = 0; i < displayheight; i++)
			{
				row = new Vector.<int>;
				
				for (j = 0; j < displaywidth ; j++)
				{
					if (Math.random()<0.5)
						row.push(0);
					else
						row.push(1);
				}
				screen.push(row);
			}
			
			drawscreen();
			printscreen();
		}
		
		private function max(a:int, b:int):int
		{
			return a < b ? b : a;
		}
		
		private function min(a:int, b:int):int
		{
			return a > b ? b : a;
		}
		
		private function drawarea(scr:int, xpos:int, ypos:int):void
		{
			for (var i:int = max(0,xpos) ; i < min(displaywidth,xpos+displaywidth); i++)
			{
				for (var j:int = max(0,ypos) ; j < min(displayheight,ypos+displayheight); j++)
				{
					screen[j][i] = area[scr][j - ypos][i - xpos];
				}
			}
		}
		
		private function recalcareas():void
		{
			
			//should push content data first? or maybe have it cached all along?
			
			var a:AreaDat;
			
			a = generateArea(cx - 1, cy - 1);
			area[0] = a.geography;
			a = generateArea(cx , cy - 1);
			area[1] = a.geography;
			a = generateArea(cx + 1, cy - 1);
			area[2] = a.geography;
			a = generateArea(cx - 1, cy );
			area[3] = a.geography;
			a = generateArea(cx , cy );
			area[4] = a.geography;
			a = generateArea(cx + 1, cy );
			area[5] = a.geography;
			a = generateArea(cx - 1, cy + 1);
			area[6] = a.geography;
			a = generateArea(cx , cy + 1);
			area[7] = a.geography;
			a = generateArea(cx + 1, cy + 1);
			area[8] = a.geography;
		}
		
		public function generateArea(x:int,y:int):AreaDat
		{
			var n:int = pointtoint(x, y);
			var ad:AreaDat = new AreaDat();
			mt.seed = n;
			var bgtile:int;

			ad.geography = new Vector.<Vector.<int>>;
			var row:Vector.<int>;
			var temp:int;
			if (x == 0 && y == 0) //starting point
			{
				for (var i:int = 0; i < displayheight; i++)
				{
					row = new Vector.<int>;
					
					for (var j:int = 0; j < displaywidth ; j++)
					{
						temp = Math.round(Math.abs(i - displaywidth / 2) + Math.abs(j - displayheight / 2));
						if ( temp>1 && temp<15 && temp%3==0 )
							row.push(4);
						else
						{
							switch (mt.int32 % 7)
							{
								case 0:
									if (mt.int32 % displaywidth > j)
									{
										row.push(13);
										break;
									}
								case 1:
								case 2:
								case 3:
									if (mt.int32 % displaywidth > j)
									{
										row.push(5);
										break;
									}
									row.push(0);
									break;
								case 4:
								case 5:
								case 6:
									row.push(3);
									break;
							}
						}
					}
					ad.geography.push(row);
				}
										
				var a:Vector.<Entity> = entityCache[n] as Vector.<Entity>;
				if (entityCache[n])
				{
					ad.entities = a;					
				}
				else
				{
					ad.entities = new Vector.<Entity>();					
				}			
			}
			else if (x == 0 ) //wall
			{
				for (i = 0; i < displayheight; i++)
				{
					row = new Vector.<int>;
					
					for (j= 0; j < displaywidth ; j++)
					{
						if (Math.abs(j - displaywidth / 2) < 4 &&  (y!=-1 || y!=1 || (y==1 && i>0) || (y==-1 && i<39)))
						{
							row.push(101);
						}
						else
						{
							temp = Math.round(Math.abs(i - displaywidth / 2) + Math.abs(j - displayheight / 2));
							switch (mt.int32 % 7)
							{
								case 0:
									if (mt.int32 % displaywidth > j)
									{
										row.push(13);
										break;
									}
								case 1:
								case 2:
								case 3:
									if (j<displaywidth/2)
									{
										row.push(5);
										break;
									}
									row.push(0);
									break;
								case 4:
								case 5:
								case 6:
								
									if (mt.int32 % displaywidth > j)
									{
										row.push(5);
										break;
									}
									row.push(3);
									break;
							}						
						}
					}
					ad.geography.push(row);			
					
				}
				
				a = entityCache[n] as Vector.<Entity>;
				if (entityCache[n])
				{
					ad.entities = a;					
				}
				else
				{
					ad.entities = new Vector.<Entity>();					
				}						
			}
			else if (x < 0) //east area
			{
				bgtile = (mt.int32 % 50) + 10;

				var density:int = 10 + (mt.int32 % 50);
				mt.setRange(0, density);
				
				var lighter:Boolean = mt.int32 % 12 == 0;
				
				for (i = 0; i < displayheight; i++)
				{
					row = new Vector.<int>;
					
					for (j= 0; j < displaywidth ; j++)
					{
						temp = mt.ranged;
						if (temp == 0)
						{
							row.push(111);
						}
						else if (temp%2==0 || 	(i * j ) % (bgtile) == 0)
						{
							row.push(0);
						}
						else
						{
							if (lighter && temp % 7 == 0)
							{
								row.push(18);
							}
							else
							{
								row.push(3);
							}
						}
					}
					ad.geography.push(row);		
				}				
				
				switch (mt.int32 % 10)
				{
					case 0:
					{
						for (var k:int = mt.int32 % 4; k > 0; k--)
						{
							var w:int = 4 + mt.int32 % (displayheight*3/4);
							var h:int = 4 + mt.int32 % (displayheight*3/4);
							var x:int = mt.int32 % (displayheight - w - 4);
							var y:int = mt.int32 % (displaywidth - h - 4);
							var floordensity:int = 2 + mt.int32 % 10;
							var walldensity:int = Math.min(Math.max(floordensity + mt.int32 % 10-5,1),20);
							var checkered:Boolean = mt.int32 % 2 == 0;
							
							//floor
							for (i = x+1; i < x + w; i++)
							{
								for (j = y+1; j < y + h; j++)
								{
									if (mt.int32 % floordensity == 0)
									{
										if (checkered && ((i + j) % 2) == 0)
											ad.geography[i][j] = 15;
										else
											ad.geography[i][j] = 16;										
									}
								}
							}
							
							
							var exit:int = mt.int32 % 4;
							var door1:Boolean = exit==0 || mt.int32 % 5 == 0;
							var door2:Boolean = exit==1 || mt.int32 % 5 == 0;
							var door3:Boolean = exit==2 || mt.int32 % 5 == 0;
							var door4:Boolean = exit == 3 || mt.int32 % 5 == 0;
							
							//wall
							for (i = x; i < x + w; i++)
							{
								if (mt.int32 % walldensity == 0)
								{
									if (!door1 || Math.abs(i-x - w/2)>1 )
										ad.geography[i][y] = 117;
										
									if (!door2 || Math.abs(i-x - w/2)>1 )
										ad.geography[i][y+h] = 117;
								}
							}
							
							for (j = y; j < y + h; j++)
							{
								if (mt.int32 % walldensity == 0)
								{
									if (!door3 || Math.abs(j-y - h/2)>1 )
										ad.geography[x][j] = 117;
										
									if (!door4 || Math.abs(j-y - h/2)>1 )
										ad.geography[x+w][j] = 117;									
								}
							}
						}
					}
					break;
					case 1:
					{
					
					}
					break;
					default:
					{
						
					}
					break;
				}
				
				
				a = entityCache[n] as Vector.<Entity>;
				if (entityCache[n])
				{
					ad.entities = a;
				}
				else
				{
					ad.entities = new Vector.<Entity>;
					if (mt.int32 % 2 == 0) // draw a black-hole one in twenty screens
					{
						var e:Entity = new Entity(mt.int32 % (displaywidth - 2 * 4) + 4, mt.int32 % (displaywidth - 2 * 4) + 4, 200);
						ad.entities.push(e);						
						ad.entities.push(new Entity(e.x+1,e.y,200));						
						ad.entities.push(new Entity(e.x-1,e.y,200));						
						ad.entities.push(new Entity(e.x,e.y+1,200));						
						ad.entities.push(new Entity(e.x,e.y-1,200));						
					}
				}
			}
			else if (x > 0) //west area
			{
				bgtile = (mt.int32 % 150) + 4;

				mt.setRange(0, 4);
				for (i = 0; i < displayheight; i++)
				{
					row = new Vector.<int>;
					
					for (j= 0; j < displaywidth ; j++)
					{
						if (mt.ranged==0 || ((i+1) * (j+1) ) % (bgtile) == 0)
							row.push(8);
						else
							row.push(5);
					}
					ad.geography.push(row);
				}			
				
				switch (mt.int32 % 10)
				{
					case 0:
					{
						const r:Number = 3 + mt.int32%(displaywidth/2-5);
						mt.setRange(r + 1, displaywidth - r - 1);
						var cx:int = mt.ranged;
						var cy:int = mt.ranged;
						for (var t:Number = 0; t < 2*3.14159; t += 3.14159 / 5)
						{
							ad.geography[Math.round(cx+Math.sin(t) * r)][Math.round(cy+Math.cos(t) * r)] = 106;
						}						
					}
					break;
					case 1:
					{
						const armlength:int = 3+(mt.int32%3);
						mt.setRange(armlength + 1, displaywidth - armlength - 1);
						cx = mt.ranged;
						cy = mt.ranged;
						for (i = 0;  i <= armlength; i++)
						{
							ad.geography[cx + i][cy] = 107;
							ad.geography[cx - i][cy] = 107;
							ad.geography[cx][cy + i] = 107;
							ad.geography[cx][cy - i] = 107;
						}							
					}
					break;
					case 2:
					{
						var separation:int = 2 + mt.int32 % 4;
						mt.setRange(0, mt.int32%10+1);
						for (i = 0; i < 25; i++)
						{
							if (mt.ranged == 0)
							{
								ad.geography[3 + separation * Math.round(i / 5)][3 + separation * (i % 5)] = 112;
							}
						}
					}
					case 3:
					{
						for (i = mt.int32 % 30; i >= 0; i--)
						{
							cx = mt.int32 % (displayheight - 1);
							cy = mt.int32 % displaywidth;
							ad.geography[cx][cy] = 112;
							ad.geography[cx+1][cy] = 112;
						}
					}
					default:
					break;
				}
				
				a = entityCache[n] as Vector.<Entity>;
				if (entityCache[n])
				{
					ad.entities = a;					
				}
				else
				{
					ad.entities = new Vector.<Entity>;
					//4250x4000
					//x>0 constraint
					//x goes from 1 to 4250 inclusive
					//y goes from -1999 to 2000 inclusive
					if (x <= 4250 && (y >= -1999 && y <= 2000))
					{
						for (i = 0; i < 20;i++)  // place 20 bodies per screen
						{
							var f:Number = mt.float;
							if (f < 00025.0/169081) //purple
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 204 );
							}
							else if (f < (00100.0+00025.0) / 169081) //pink
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 205 );
							}
							else if (f < (03000.0+00100.0+00025.0) / 169081) //brown
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 207 );
							}
							else if (f < (01700.0+03000.0+00100.0+00025.0)/ 169081) //black
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 206 );
							}
							else if (f < (31000.0 + 01700.0+03000.0+00100.0+00025.0)/ 169081) //red
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 201 );
							}
							else if (f < (57000.0 + 31000.0 + 01700.0+03000.0+00100.0+00025.0)/ 169081) //yellow
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 208 );
							}
							else //if (f < (18500.0+60000.0+57000.0 + 31000.0 + 01700.0+03000.0+00100.0+00025.0)/ 169081) //blue
							{
								e = new Entity(mt.int32 % (displaywidth), mt.int32 % (displaywidth), 203 );
							}
							
							ad.entities.push(e);						
						}
					}
				}
			
			}
			
			ad.drawEntities();
			return ad;
		}
		
		private function drawscreen():void
		{
			var sx:int = px - xoffset;
			var sy:int = py - yoffset;
			drawarea(0, sx+displaywidth,sy+displayheight);
			drawarea(1, sx,sy+displayheight);
			drawarea(2, sx-displaywidth,sy+displayheight);
			drawarea(3, sx+displaywidth,sy);
			drawarea(4, sx,sy);
			drawarea(5, sx-displaywidth,sy);
			drawarea(6, sx+displaywidth,sy-displayheight);
			drawarea(7, sx,sy-displayheight);
			drawarea(8, sx - displaywidth, sy - displayheight);
			
			screen[xoffset][yoffset] = 2;
		}
		
		//spiral
		public function pointtoint(x:int, y:int):int
		{
			if (x >= 0 && y >= 0)
			{
				if (x > y)
				{
					return x*(4*x-1)-y;
				}
				else
				{
					return y*(4*y-3)+x;					
				}
			}
			else if (x >= 0 && y < 0 )
			{
				if (x > (-y) )
				{
					return x*(4*x-1)-y;
				}
				else
				{
					return (-y)*(4*(-y)+1)-x;					
				}
			}
			else if (x<0 && y>=0)
			{
				if ( (-x) >= y )
				{
					return (-x)*(4*(-x)+3)+y;
				}
				else	
				{
					return y*(4*y-3)-(-x);					
				}				
			}
			else if (x < 0 && y < 0)
			{
				if ( (-x) > (-y) )
				{
					return (-x)*(4*(-x)+3)+y;
				}
				else
				{
					return (-y)*(4*(-y)+1)+(-x);					
				}
			}
			
			//should never get here
			return -1;
		}
		
		
		private function printscreen():void
		{
			var r:Rectangle = new Rectangle;
			r.width = tilesize;
			r.height = tilesize;
			var bData:BitmapData = FlxG.buffer;
			
			if (!bData)
				return;
				
			for (var i:int = 0; i < displaywidth; i++)
			{
				for (var j:int = 0; j < displayheight; j++)
				{
					r.x = i * tilesize;
					r.y = j * tilesize;
										
					switch(screen[j][i])
					{
						//reserve 100+ for impassable
						
						//51+ for passable
						case 0:
							bData.fillRect(r, 0xff222200);
							break;							
						case 101:
							bData.fillRect(r, 0xff333333);
							break;								
						case 2:
						{
							if (carrying > 200 && elapsed >= 0.1)
							{
								switch(carrying)
								{
									case 201: //red
										bData.fillRect(r, 0xff800000);
									break;
									case 202: //green
										bData.fillRect(r, 0xff008000);
									break;
									case 203: //blue
										bData.fillRect(r, 0xff002780);
									break;
									case 204: //purple
										bData.fillRect(r, 0xff800051);
									break;
									case 205: //pink
										bData.fillRect(r, 0xffff7a8e);
									break;
									case 206: //black
										bData.fillRect(r, 0xff262626);
									break;
									case 207: //brown
										bData.fillRect(r, 0xff692200);
									break;
									case 208: //yellow
										bData.fillRect(r, 0xfffcff0f);
									break;
								}
							}
							else
							{
								bData.fillRect(r, 0xffff0000);
							}
							
							break;
						}
						case 3:
							bData.fillRect(r, 0xff223300);
							break;	
						case 4:
							bData.fillRect(r, 0xffaa7733);
							break;	
						case 5:
							bData.fillRect(r, 0xff664422);
							break;	
						case 106:
							bData.fillRect(r, 0xffaa9477);
							break;	
						case 107:
							bData.fillRect(r, 0xffccaa66);
							break;	
						case 8:
							bData.fillRect(r, 0xff443322);
							break;						
						case 109:
							bData.fillRect(r, 0xff997784);
							break;						
						case 110:
							bData.fillRect(r, 0xff887788);
							break;		
						case 111:
							bData.fillRect(r, 0xff55cc44);
							break;
						case 112:
							bData.fillRect(r, 0xffcc8833);
							break;
						case 13:
							bData.fillRect(r, 0xff443322);
							break;						
						case 114:
							bData.fillRect(r, 0xff777777);
							break;
						case 15:
							bData.fillRect(r, 0xff557755);
							break;
						case 16:
							bData.fillRect(r, 0xff446644);
							break;
						case 117:
							bData.fillRect(r, 0xff88aabb);
							break;
						case 18:
							bData.fillRect(r, 0xff444411);
							break;
						case 200: //hole
							bData.fillRect(r, 0xff000000);
							break;
						case 201: //red
							bData.fillRect(r, 0xff800000);
						break;
						case 202: //green
							bData.fillRect(r, 0xff008000);
						break;
						case 203: //blue
							bData.fillRect(r, 0xff002780);
						break;
						case 204: //purple
							bData.fillRect(r, 0xff800051);
						break;
						case 205: //pink
							bData.fillRect(r, 0xffff7a8e);
						break;
						case 206: //black
							bData.fillRect(r, 0xff262626);
						break;
						case 207: //brown
							bData.fillRect(r, 0xff692200);
						break;
						case 208: //yellow
							bData.fillRect(r, 0xfffcff0f);
						break;
					}
				}
			}
			
			screen[xoffset][yoffset] = 2;
		}

		override public function update():void
		{
			elapsed += FlxG.elapsed;
			if (elapsed > 0.2)
				elapsed -= 0.2;
				
			elapsed2 += FlxG.elapsed;
			if (elapsed2 > 0.05)
			{
				elapsed2 -= 0.05;
			}
			else
			{
				super.update();
				printscreen();
				return;
			}
				
			var bChanged:Boolean = false;
			var bForceRefresh:Boolean = false;
			var bCheckLocation:Boolean = false;
			var nColor:int = 0;
			var offx:int = 0;
			var offy:int = 0;
			if (FlxG.keys.UP)
			{
				if (screen[xoffset-1-offy][yoffset-offx] < 100)
				{
					py++;
					offy++;
					bChanged = true;
				}
				else if (screen[xoffset - 1-offy][yoffset-offx] == 200 && carrying!=0) // HOLE
				{
					nColor = screen[xoffset - 1-offy][yoffset-offx];
					py++;
					offy++;
					bCheckLocation = true;
					bChanged = true;
				}
				else if (screen[xoffset - 1-offy][yoffset-offx] > 200 && carrying==0) // PICK UP CORPSE
				{
					nColor = screen[xoffset - 1-offy][yoffset-offx] ;
					py++;
					offy++;
					bCheckLocation = true;
					bChanged = true;
				}
			}
			if (FlxG.keys.DOWN)//("DOWN"))
			{
				if (screen[xoffset+1-offy][yoffset-offx] < 100)
				{
					py--;
					offy--;
					bChanged = true;
				}
				else if (screen[xoffset + 1-offy][yoffset-offx] == 200 && carrying!=0) // HOLE
				{
					nColor = screen[xoffset + 1][yoffset-offx];
					py--;
					offy--;
					bCheckLocation = true;
					bChanged = true;
				}
				else if (screen[xoffset + 1-offy][yoffset-offx] > 200 && carrying==0) // PICK UP CORPSE
				{
					nColor = screen[xoffset + 1-offy][yoffset-offx];
					py--;
					offy--;
					bCheckLocation = true;
					bChanged = true;
				}
			}
			if (FlxG.keys.LEFT &&!bCheckLocation)//("LEFT"))
			{
				if (screen[xoffset-offy][yoffset-1-offx] < 100)
				{
					px++;
					offx++;
					bChanged = true;
				}
				else if (screen[xoffset-offy][yoffset-offx-1] == 200 && carrying!=0) // HOLE
				{
					nColor = screen[xoffset-offy][yoffset-1-offx];
					px++;
					offx++;
					bCheckLocation = true;
					bChanged = true;
				}
				else if (screen[xoffset-offy][yoffset-offx-1] > 200 && carrying==0) // PICK UP CORPSE
				{
					nColor = screen[xoffset-offy][yoffset-1-offx];
					px++;
					offx++;
					bCheckLocation = true;
					bChanged = true;
				}
			}
			if (FlxG.keys.RIGHT &&!bCheckLocation)//("RIGHT"))
			{
				if (screen[xoffset-offy ][yoffset+1-offx] < 100)
				{
					px--;
					offx--;
					bChanged = true;
				}
				else if (screen[xoffset-offy ][yoffset+1-offx] == 200 && carrying!=0) // HOLE
				{
					nColor = screen[xoffset-offy][yoffset+1-offx];
					px--;
					offx--;
					bCheckLocation = true;
					bChanged = true;
				}
				else if (screen[xoffset-offy ][yoffset+1-offx] > 200 && carrying==0) // PICK UP CORPSE
				{
					nColor = screen[xoffset-offy][yoffset+1-offx];
					px--;
					offx--;
					bCheckLocation = true;
					bChanged = true;
				}
			}
			
			if (bChanged)
			{
				if (px < 0 || py < 0 || px > displaywidth || py > displayheight)
				{
					if (px < 0)
					{
						cx--;
						px += displaywidth
					}
					if (py < 0)
					{
						cy--;
						py += displayheight;
					}
					if (px >= displaywidth)
					{
						cx++;
						px -= displaywidth;
					}
					if (py >= displayheight)
					{
						cy++;
						py -= displayheight;
					}
					trace("P", px, py,cx,cy);
					recalcareas();					
				}				
				drawscreen();
				
				if (bCheckLocation)
				{
					if (nColor == 200) // HOLE
					{
						var ad:AreaDat = generateArea(cx, cy);
						for (var i:int = 0; i < ad.entities.length; i++)
						{						
							var e:Entity = ad.entities[i];
							if (e.x == 40-py && e.y == 40-px)
							{
								ad.entities.splice(i, 1);
								break;
							}
						}
						var n:int = pointtoint(cx, cy);
						entityCache[n] = ad.entities;
						carrying = 0;
						bChanged = true;
						bForceRefresh = true;
						unburied--;						
						FlxG.play(MenuState.SndBlip);
						unburiedLbl.text = unburied.toString() + " people unburied";
						if (unburied == 0)
						{
							FlxG.state = new VictoryState();
						}
					}
					else if (nColor > 200) // PICK UP CORPSE
					{
						trace(40-py,40-px,cx, cy, nColor);
						ad = generateArea(cx, cy);
						var bFound:Boolean = false;
						for (i = 0; i < ad.entities.length; i++)
						{
							e = ad.entities[i];
							if (e.x == 40-py && e.y == 40-px)
							{
								trace("E",e.x, e.y);
								ad.entities.splice(i, 1);
								bFound = true;
								break;
							}
						}
						n = pointtoint(cx, cy);
						entityCache[n] = ad.entities;
						carrying = nColor;	
						FlxG.play(MenuState.SndBang);
						bChanged = true;
						bForceRefresh = true;
					}
				}
				
				if (bForceRefresh)
				{
					recalcareas();
					drawscreen();
				}
			}
			
			super.update();
			printscreen();
		}

	}
}

class Entity
{
	public var x:int;
	public var y:int;
	public var name:int;
	public function Entity(x_:int, y_:int, name_:int):void 
	{
		x = x_;
		y = y_;
		name = name_;
	}
}

class AreaDat
{
	public var geography:Vector.<Vector.<int>>;
	public var entities:Vector.<Entity>;
	public function drawEntities():void
	{
		for each (var e:Entity in entities)
		{
			geography[e.x][e.y] = e.name;
		}
	}
}

/*
Code orignally written by Ger Hobolt
Available at http://flashexperiments.insh-allah.com/

I simply put it into a Class file to make it easier to use


Function:    MersenneTwister()
Description: Initializes the class
Example:     var mt:MersenneTwister = new MersenneTwister()


Function:    seedMT(seed)
Description: Sets the seed to be used. If the same seed
             is used twice, the same numbers will show up.
			 This function also makes the seed odd to help
			 better generate numbers.
Example:     var mt:MersenneTwister = new MersenneTwister()
             mt.seedMT(5)
			 
			 
Function:    reloadMT()
Description: Called internally, you shouldn't need to use this yourself.


Function:    randomMT()
Description: Returns unscaled random numbers
Example:     var mt:MersenneTwister = new MersenneTwister()
             mt.seedMT(5)
			 trace(mt.randomMT())
			 //The output is 530851887
			 
			 
Function:    rangedMT(low, high)
Description: Returns whole numbers between (and
			 including) the low and high inputs.
Example:     var mt:MersenneTwister = new MersenneTwister()
             mt.seedMT(9)
			 for (var i=0;i<5;i++) {
			 	trace(mt.rangedMT(0, 3))
			 }
			 //The output is 2
							 1
							 3
							 2
							 0
							 
			 
*/

class MersenneTwister
{
	protected static const 
		N:int = 624,
		M:int = 397,
		MATRIX_A:uint = 0x9908b0df,
		UPPER_MASK:uint = 0x80000000,
		LOWER_MASK:uint = 0x7fffffff;

	protected var
		mt:Vector.<uint> = new Vector.<uint>(N),
		mti:int = N+1,
		mag01:Array = [0, MATRIX_A],
		s:uint,
		rangeStart:uint = 0,
		rangeEnd:uint = 0;

	/**
	 * constructor
	 * 
	 * @param seed the random seed
	 */
	public function set seed(seed:uint):void
	{
		initialize(seed);
		s = seed;
	}
	
	/**
	 * sets the range to be used
	 * 
	 * must be set before using 'ranged' to get random numbers
	 *
	 * @param min the range start
	 * @param max the range end
	 */
	public function setRange(min:uint, max:uint):void
	{
		if(min >= max)
			throw new Error('min can not be greater or equal to max');

		rangeStart = min;
		rangeEnd = max-min+1;
	}
	
	/**
	 * initializes mt[N] with a seed
	 * 
	 * @param seed the random seed
	 */
	protected function initialize(seed:uint):void
	{
		mt[0] = seed & 0xffffffff;
		for(mti=1; mti<N; mti++)
		{
			mt[mti] = (1812433253 * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti); 
			mt[mti] &= 0xffffffff;
		}
	}

	/**
	 * generates a random number between 0 and 0xffffffff
	 * 
	 * @return random int number
	 */
	public function get int32():uint
	{
		var y:uint;

		// generates N numbers at once every N numbers
		if(mti >= N)
		{
			var kk:int;
			
			for(kk=0;kk<N-M;kk++)
			{
				y = (mt[kk] & UPPER_MASK) | (mt[kk+1] & LOWER_MASK);
				mt[kk] = mt[kk+M] ^ (y >> 1) ^ mag01[y & 0x1];
			}
			for (;kk<N-1;kk++)
			{
				y = (mt[kk] & UPPER_MASK) | (mt[kk+1] & LOWER_MASK);
				mt[kk] = mt[kk+(M-N)] ^ (y >> 1) ^ mag01[y & 0x1];
			}
			y = (mt[N-1] & UPPER_MASK) | (mt[0] & LOWER_MASK);
			mt[N-1] = mt[M-1] ^ (y >> 1) ^ mag01[y & 0x1];
			
			// resets counter
			mti = 0;
		}

		y = mt[mti++];
	
		// tempering
		y ^= (y >> 11);
		y ^= (y << 7) & 0x9d2c5680;
		y ^= (y << 15) & 0xefc60000;
		y ^= (y >> 18);

		return y;
	}

	/**
	 * generates a random number between 0 and 1
	 *
	 * takes an int32 random number and divides it by 2^(32-1),
	 * this might not be very right but it should still be acceptable 
	 * for most usages
	 *
	 * @return random float number
	 */
	public function get float():Number
	{
		return int32/2147483647;
	}
	
	/**
	 * generates a random number comprised in the user defined range
	 * 
	 * @return random int number
	 */
	public function get ranged():uint
	{
		return rangeStart + float * rangeEnd;
	}

	/**
	 * the seed set in the constructor, read-only
	 * 
	 * @return the seed used to generate the numbers
	 */
	public function get seed():uint
	{
		return s;
	}
}